
package jac.ide;

import jac.lib.java.util.Vector;
import java.util.Set;
import jac.core.ACManager;

public class AspectConfiguration {

   public String toString() {
      if( name != null ) {
         return name;
      } else {
         return super.toString();
      }
   }

   String name;
   
   /**
    * Get the value of name.
    * @return value of name.
    */
   public String getName() {
      return name;
   }
   
   /**
    * Set the value of name.
    * @param v  Value to assign to name.
    */
   public void setName(String  v) {
      this.name = v;
   }

   public static Set getDeclaredAspects(Object substance) {
      return ((ACManager)ACManager.get()).getDeclaredACs();
   }

   Aspect aspect;
   
   /**
    * Get the value of aspect.
    * @return value of aspect.
    */
   public Aspect getAspect() {
      return aspect;
   }
   
   /**
    * Set the value of aspect.
    * @param v  Value to assign to aspect.
    */
   public void setAspect(Aspect  v) {
      this.aspect = v;
   }
      
   boolean woven;
   
   /**
    * Get the value of woven.
    * @return value of woven.
    */
   public boolean isWoven() {
      return woven;
   }
   
   /**
    * Set the value of woven.
    * @param v  Value to assign to woven.
    */
   public void setWoven(boolean  v) {
      this.woven = v;
   }
   
   String configurationCode;
   
   /**
    * Get the value of configurationCode.
    * @return value of configurationCode.
    */
   public String getConfigurationCode() {
      return configurationCode;
   }
   
   /**
    * Set the value of configurationCode.
    * @param v  Value to assign to configurationCode.
    */
   public void setConfigurationCode(String  v) {
      this.configurationCode = v;
   }

   String defaultConfigurationCode;
   
   /**
    * Get the value of defaultConfigurationCode.
    * @return value of defaultConfigurationCode.
    */
   public String getDefaultConfigurationCode() {
      return defaultConfigurationCode;
   }
   
   /**
    * Set the value of defaultConfigurationCode.
    * @param v  Value to assign to defaultConfigurationCode.
    */
   public void setDefaultConfigurationCode(String  v) {
      this.defaultConfigurationCode = v;
   }
      
}
