
package jac.ide;

import jac.lib.java.util.Vector;

public abstract class ModelElement {

   public ModelElement() {}

   public ModelElement(String name) {
      this.name = name;
   }

   String name="";
   
   public void setName(String name) {
      this.name=name;
   }

   public String getFullName() {
      return name;
   }

   public String getName() {
      return name;
   }

   public String toString() {
      return name;
   } 

   public Type getType() {
      return Projects.types.resolveType("void","");
   } 

   Vector endingLinks;
   
   /**
    * Get the value of endingLinks.
    * @return value of endingLinks.
    */
   public Vector getEndingLinks() {
      return endingLinks;
   }
   
   /**
    * Set the value of endingLinks.
    * @param v  Value to assign to endingLinks.
    */
   public void setEndingLinks(Vector  v) {
      this.endingLinks = v;
   }
   
   public void addEndingLink(Link l) {
      endingLinks.add(l);
   }

   public void removeEndingLink(Link l) {
      endingLinks.remove(l);
   }

   String description;
   
   /**
    * Get the value of description.
    * @return value of description.
    */
   public String getDescription() {
      return description;
   }
   
   /**
    * Set the value of description.
    * @param v  Value to assign to description.
    */
   public void setDescription(String  v) {
      this.description = v;
   }
   
}
