
package jac.ide;

import  jac.lib.java.util.Vector;
import jac.core.ObjectRepository;
import jac.core.rtti.ClassRepository;
import jac.core.rtti.NamingConventions;
import java.util.Collection;

public class RoledLink extends Link {

   public static int ORIENTATION_BOTH = 0;
   public static int ORIENTATION_STRAIGHT = 1;
   public static int ORIENTATION_REVERSE = -1;

   int orientation=0;
   
   /**
    * Get the value of orientation.
    * @return value of orientation.
    */
   public int getOrientation() {
      return orientation;
   }
   
   /**
    * Set the value of orientation.
    * @param v  Value to assign to orientation.
    */
   public void setOrientation(int  v) {
      this.orientation = v;
   }
   

   String startCardinality="0-1";
   
   /**
    * Get the value of startCardinality.
    * @return value of startCardinality.
    */
   public String getStartCardinality() {
      return startCardinality;
   }
   
   /**
    * Set the value of startCardinality.
    * @param v  Value to assign to startCardinality.
    */
   public void setStartCardinality(String  v) {
      this.startCardinality = v;
   }
   
   String endCardinality="0-1";
   
   /**
    * Get the value of endCardinality.
    * @return value of endCardinality.
    */
   public String getEndCardinality() {
      return endCardinality;
   }
   
   /**
    * Set the value of endCardinality.
    * @param v  Value to assign to endCardinality.
    */
   public void setEndCardinality(String  v) {
      this.endCardinality = v;
   }

   String startRole;
   
   /**
    * Get the value of startRole.
    * @return value of startRole.
    */
   public String getStartRole() {
      return startRole;
   }
   
   /**
    * Set the value of startRole.
    * @param v  Value to assign to startRole.
    */
   public void setStartRole(String  v) {
      this.startRole = v;
   }
   
   String endRole;
   
   /**
    * Get the value of endRole.
    * @return value of endRole.
    */
   public String getEndRole() {
      return endRole;
   }
   
   /**
    * Set the value of endRole.
    * @param v  Value to assign to endRole.
    */
   public void setEndRole(String  v) {
      this.endRole = v;
   }
   
   public void setStart(ModelElement  v) {
      start=v;
      startRole=NamingConventions.lowerFirst(v.getName());
   }

   public void setEnd(ModelElement  v) {
      end=v;
      endRole=NamingConventions.lowerFirst(v.getName());
   }

   /*public static Collection endChoices(Object substance) {
      return ObjectRepository.getObjects(ClassRepository.get().getClass(Class.class));
      }*/

}


