
package jac.ide.diagrams;

import CH.ifa.draw.figures.*;
import java.util.Vector;
import java.util.Iterator;
import java.util.StringTokenizer;
import CH.ifa.draw.util.StorableInput;
import CH.ifa.draw.util.StorableOutput;
import java.io.IOException;
import jac.core.NameRepository;

public class ClassNameFigure extends TextFigure {

   jac.ide.Class substance;
   
   /**
    * Get the value of substance.
    * @return value of substance.
    */
   public jac.ide.Class getSubstance() {
      return substance;
   }
   
   /**
    * Set the value of substance.
    * @param v  Value to assign to substance.
    */
   public void setSubstance(jac.ide.Class  v) {
      this.substance = v;
   }
   
   public String getPrototype() {
      String text = getText();
      int sep = text.indexOf(':');
      if(sep == -1) {
         return "void "+text;
      } else {
         return text.substring(sep+1)+" "+text.substring(0,sep);
      }      
   }

   public String getName() {
      return getText();
   }

   public void setText(String s) {
      super.setText(s);
      if( substance != null && !DiagramView.init ) {
         substance.setName(s);
      }
   }

}
