
package jac.ide.diagrams;

import java.awt.*;

import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import jac.ide.Diagram;

import jac.core.rtti.ClassRepository;

public  class InstanceFigureCreationTool extends CreationTool {

   public InstanceFigureCreationTool(DrawingEditor newDrawingEditor) {
      super(newDrawingEditor);
   }

   public void chooseInstance(jac.ide.Instance clazz) {}

   protected Figure createFigure() {
      Object[] parameters = new Object[] {null};
      boolean result = DiagramView.display.showInput(
         this,ClassRepository.get().getClass(getClass()).getMethod("chooseInstance"),
         parameters);
      InstanceFigure cf = null;
      if( result ) {
         cf = new InstanceFigure();
         if( parameters[0] != null ) {
            cf.setSubstance((jac.ide.Instance)parameters[0]);
            cf.setContainerPackage(((jac.ide.Diagram)((DiagramView)editor()).getSubstance()).getContainer());

            cf.initInstance();
         }
      }
      editor().toolDone();
      return cf;
   }
}
