package jac.samples.bank;

import java.io.*;
import jac.core.*;

/**
 * The default launcher for the bank program.<p>
 *
 * It creates a root account manager that creates a bank with the 1
 * number.<p>
 *
 * @see AccountManager
 * @see Bank
 *
 * @author <a href="mailto:maxime@aopsys.com">Maxime Pawlak</a>
 * @author <a href="mailto:pawlak@cnam.fr">Renaud Pawlak</a> */

public class Run{

   /**
    * The program entry point.<p>
    *
    * @param args the command-line parameters (unused)
    */

   public static void main(String[] args) {
      AccountManager am = new AccountManager();
   }
}



