package jac.util;

public class Strings
{
   public static String unslashify (String str) {
      StringBuffer ret = new StringBuffer(str.length());
      int i=0;
      while(i<str.length()) {
         char c = str.charAt(i++);
         if (c == '\\') {
            c = str.charAt(i++);
            switch (c) {
               case 't': c='\t'; break;
               case 'r': c='\r'; break;
               case 'n': c='\n'; break;
               case 'f': c='\f'; break;
               case '_': c=' '; break;
            }
         } 
         ret.append(c);
      }
      return ret.toString();
   }

   public static String slashify(String str) {
      StringBuffer ret = new StringBuffer(str.length());
      for(int i=0; i<str.length(); i++) {
         char c = str.charAt(i);
         switch (c) {
            case '\t': ret.append("\\t"); break;
            case '\r': ret.append("\\r"); break;
            case '\n': ret.append("\\n"); break;
            case '\f': ret.append("\\f"); break;
            case ' ': ret.append("\\_"); break;
            default: ret.append(c); break;
         }
      }
      return ret.toString();
   }

}
