package jac.core;

import java.io.Serializable;

public class ConfigMethod implements Serializable, Cloneable {
   String methodName;
   Object[] args;
   String lineNumber;
   public ConfigMethod(String methodName, Object[] args, String lineNumber) {
      this.methodName = methodName;
      this.args = args;
      this.lineNumber = lineNumber;
   }
   public ConfigMethod(String methodName, Object[] args) {
      this.methodName = methodName;
      this.args = args;
      this.lineNumber = "???:???";
   }
   public String getMethod() {
      return methodName;
   }
   public Object[] getArgs() {
      return args;
   }
   public void setArgs(Object[] args) {
      this.args = args;
   }
   public String getLineNumber() {
      return lineNumber;
   }
   public String toString() {
      return "ConfigMethod("+methodName+","+java.util.Arrays.asList(args)+")";
   }
   public Object clone() throws CloneNotSupportedException {
      return super.clone();
   }
}
