
package jac.ide;

import  jac.lib.java.util.Vector;
import java.util.Iterator;

public class Method extends Member {
  
   public String getPrototype() {
      return ((type==null)?"void":type.getFullName())+
         " "+name+"("+getParametersString()+")";
   }

   public String toString() {
      return name+"("+getParametersString()+"):"+
         ((type==null)?"void":type.toString());

   }

   String getParametersString() {
      String result="";
      if(parameters == null) return result;
      Iterator it = parameters.iterator();
      while(it.hasNext()) {
         Parameter cur = (Parameter)it.next();
         result=result+cur.getPrototype();
         if(it.hasNext()) {
            result=result+", ";
         }
      }
      return result;
   }

   Vector parameters=new Vector();
   
   /**
    * Get the value of parameters.
    * @return value of parameters.
    */
   public Vector getParameters() {
      return parameters;
   }
   
   /**
    * Set the value of parameters.
    * @param v  Value to assign to parameters.
    */
   public void setParameters(Vector  v) {
      this.parameters = v;
   }
   
   public void addParameter(Parameter p) {
      parameters.add(p);
   }

   public void removeParameter(Parameter p) {
      parameters.remove(p);
   }

   String body;
   
   /**
    * Get the value of body.
    * @return value of body.
    */
   public String getBody() {
      return body;
   }
   
   /**
    * Set the value of body.
    * @param v  Value to assign to body.
    */
   public void setBody(String  v) {
      this.body = v;
   }   

}
