
package jac.ide;

import jac.lib.java.util.Vector;
import java.util.List;

public class Project extends ModelElement {

   public void generateCode() {
      if (generationPath!=null)
         CodeGeneration.createProjectCode(this,generationPath.getPath());
      else 
         new Exception("Project does not have a generation path");
   }

   public Errors compile() {
      return CodeGeneration.compileProjectCode(this,generationPath.getPath());
   }

   java.net.URL generationPath;
   
   /**
    * Get the value of generationPath.
    * @return value of generationPath.
    */
   public java.net.URL getGenerationPath() {
      return generationPath;
   }
   
   /**
    * Set the value of generationPath.
    * @param v  Value to assign to generationPath.
    */
   public void setGenerationPath(java.net.URL  v) {
      this.generationPath = v;
   }   

   Vector packages=new Vector();
   
   /**
    * Get the value of packages.
    * @return value of packages.
    */
   public Vector getPackages() {
      return packages;
   }
   
   /**
    * Set the value of packages.
    * @param v  Value to assign to packages.
    */
   public void setPackages(Vector  v) {
      this.packages = v;
   }
   
   public void addPackage(Package p) {
      packages.add(p);
   }
   
   public void removePackage(Package p) {
      packages.remove(p);
   }

   Vector applications;
   
   /**
    * Get the value of applications.
    * @return value of applications.
    */
   public Vector getApplications() {
      return applications;
   }
   
   /**
    * Set the value of applications.
    * @param v  Value to assign to applications.
    */
   public void setApplications(Vector  v) {
      this.applications = v;
   }
   
   public void addApplication(Application a) {
      applications.add(a);
      a.setProject(this);
   }

   public void removeApplication(Application a) {
      applications.remove(a);
   }

}
