
package jac.ide;

public class Type extends ModelElement {

   public Type() {}

   public Type(String name) {
      this.name = name;
   }

   public String getFullName() {
      if( packagePath != null && !packagePath.equals("") ) {
         return packagePath+"."+name;
      } else {
         return name;
      }
   }

   public boolean isPrimitive() {
      return Character.getType(name.charAt(0))==Character.LOWERCASE_LETTER;
   }

   String packagePath="";
   
   /**
    * Get the value of packagePath.
    * @return value of packagePath.
    */
   public String getPackagePath() {
      return packagePath;
   }
   
   /**
    * Set the value of packagePath.
    * @param v  Value to assign to packagePath.
    */
   public void setPackagePath(String  v) {
      this.packagePath = v;
   }
   
}
