
package jac.ide;

import  jac.lib.java.util.Vector;

public abstract class TypedElement extends ModelElement {
   
   Type type;
   
   /**
    * Get the value of type.
    * @return value of type.
    */
   public Type getType() {
      return type;
   }
   
   /**
    * Set the value of type.
    * @param v  Value to assign to type.
    */
   public void setType(Type  v) {
      this.type = v;
   }

   public String getPrototype() {
      return type+" "+name;
   }
   
   public String toString() {
      return name+":"+type;
   }

}
