package jac.ide.diagrams;

import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.Geom;
import CH.ifa.draw.util.UndoableAdapter;
import CH.ifa.draw.util.Undoable;
import java.awt.*;
import java.awt.event.MouseEvent;
import java.util.*;
import jac.util.Log;

public  class AggregationCreationTool extends RelationLinkCreationTool {

   public AggregationCreationTool(DrawingEditor newDrawingEditor, ConnectionFigure newPrototype) {
      super(newDrawingEditor,newPrototype);
   }

   protected void createRelation(ClassFigure source, ClassFigure target) {
      if(source.getSubstance() != null && target.getSubstance() != null ) {
         jac.ide.RelationLink rel = new jac.ide.RelationLink();
         rel.setStart((jac.ide.Class)source.getSubstance());
         rel.setEnd((jac.ide.Class)target.getSubstance());
         ((RelationLinkFigure)getConnection()).setSubstance(rel);
         ((jac.ide.Class)source.getSubstance()).addRelationLink(rel);
         AttachedTextFigure name = AttachedTextFigure.createName();
         name.setSubstance(rel);
         name.setText("newAggregation");
         name.connect(((RelationLinkFigure)getConnection()));
         view().add(name);
         rel.setAggregation(true);
         ArrowTip arrow = new ArrowTip(0.50, 15, 28);
         arrow.setFillColor(Color.white);
         ((RelationLinkFigure)getConnection()).setStartDecoration(arrow);
         ((jac.core.Wrappee)rel).invokeRoleMethod("addView",new Object[]{getConnection()});
      }
   }
}
