
package jac.ide.diagrams;

import java.awt.*;
import java.util.*;
import java.io.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.*;
import jac.core.NameRepository;
import jac.core.Wrappee;
import jac.aspects.gui.View;
import jac.util.Log;

public class AspectFigure extends ClassFigure {

   protected void drawBorder(Graphics g) {
      
      Rectangle r = displayBox();
      
      g.setColor(Color.orange);

      g.fillRect(r.x, r.y, r.width, r.height);
      
      g.setColor(Color.red);
      
      g.drawRect(r.x, r.y, r.width, r.height);
      
      
      Figure f = figureAt(0);
      Rectangle rf = f.displayBox();
      
      g.drawLine(r.x,r.y+rf.height+1,r.x+r.width,r.y+rf.height+1);
      
      if( fieldFigures.size() > 0 ) {
         f = (Figure) fieldFigures.get(0);
         rf = f.displayBox();
         g.drawLine(r.x,rf.y,r.x+r.width,rf.y);
      }
      
   }

}
