
package jac.ide.diagrams;

import java.awt.*;

import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import jac.ide.Diagram;

import jac.core.rtti.ClassRepository;

public  class ClassFigureCreationTool extends CreationTool {

   public ClassFigureCreationTool(DrawingEditor newDrawingEditor) {
      super(newDrawingEditor);
   }

   public void chooseClass(jac.ide.Class clazz) {}

   protected Figure createFigure() {
      Object[] parameters = new Object[] {null};
      boolean result = DiagramView.display.showInput(
         this,ClassRepository.get().getClass(getClass()).getMethod("chooseClass"),
         parameters);
      ClassFigure cf = null;
      if( result ) {
         cf = new ClassFigure();
         if( parameters[0] != null ) {
            cf.setSubstance((jac.ide.Class)parameters[0]);
            cf.setContainerPackage(((jac.ide.Diagram)((DiagramView)editor()).getSubstance()).getContainer());

            cf.initClass();
         }
      }
      //cf.linkToClass(((DiagramApplet)editor()).getSubstance());
      editor().toolDone();
      return cf;
   }
}
