
package jac.ide.diagrams;

import CH.ifa.draw.figures.*;
import java.util.Vector;
import java.util.Iterator;
import java.util.StringTokenizer;
import CH.ifa.draw.util.StorableInput;
import CH.ifa.draw.util.StorableOutput;
import java.io.IOException;
import jac.core.NameRepository;

public class InstanceNameFigure extends TextFigure {

   jac.ide.Instance substance;
   
   /**
    * Get the value of substance.
    * @return value of substance.
    */
   public jac.ide.Instance getSubstance() {
      return substance;
   }
   
   /**
    * Set the value of substance.
    * @param v  Value to assign to substance.
    */
   public void setSubstance(jac.ide.Instance  v) {
      this.substance = v;
   }
   
   public String getName() {
      return getText();
   }

   public void setText(String s) {
      super.setText(s);
      if( substance != null && !DiagramView.init ) {
         if( s.indexOf(":") != -1 ) {
            substance.setName(s.substring(0,s.indexOf(":")));
         } else {
            substance.setName(s);
         }
      }
   }

}
