/*
  Copyright (C) AOPSYS (http://www.aopsys.com)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

package jac.samples.calcul;

import jac.core.*;
import jac.core.rtti.*;
import jac.aspects.gui.*;

public class UserDefinedWrapper extends Wrapper  {

   /*
     public Object confirm()
        throws ActionCanceledException
     {

        if( ! (wrappee() instanceof Calcul) ) return proceed();

        Display display = (Display)attr("Gui.display");
        if (display==null) return proceed();
      
        if( method().equals("add") ) {
  
           if ( ! display.showConfirm( "Are you sure to add " + arg(0) + 
                                       " to " + wrappee() + " ?" ) ) {
              throw new ActionCanceledException();
           }
        }
        return proceed();
     }
   */

   public Object myWrappingMethod() {
      Object ret=null;
      System.out.println("Before "+method()+":"+arg(0));
      ret=proceed();
      System.out.println("After "+method());
      return ret;
   }

}

class ActionCanceledException extends Exception {}








