
package jac.samples.contacts;

import jac.lib.java.util.Vector;
import gnu.regexp.*;
import java.util.Iterator;

public class ContactRepository {
   Vector contacts = new Vector();

   public Vector getContacts() {
      return contacts;
   }
   
   public void addContact( Person contact ) {
      contacts.add( contact );
   }

   public void removeContact( Person contact ) {
      contacts.remove( contact );
   }

   public java.util.Vector find(String criteria,String company) {
      java.util.Vector result = new java.util.Vector();
      java.util.Iterator it = contacts.iterator();
      if( criteria.equals("") ) criteria = ".*";
      RE recrit = null;
      try {
         recrit = new RE(criteria);
      } catch( Exception e ) {
         e.printStackTrace();
         return result;
      }
      while( it.hasNext() ) {
         Person contact = (Person) it.next();
         System.out.println("testing contact "+contact);
         String companyName = "";
         if( ! company.equals("") ) {
            if( contact.getCompany() != null ) {
               companyName = contact.getCompany().getName();
               if( ! company.equals( companyName ) ) {
                  System.out.println("skipped");
                  continue;
               }
            }
         }
         if( recrit.isMatch( contact.getLastName() ) ) {
            result.add(contact);
            System.out.println("Contact "+contact+" added to filtered");
         }
         if( recrit.isMatch( contact.getFirstName() ) ) {
            result.add(contact);
            System.out.println("Contact "+contact+" added to filtered");
         }
      }
      return result;
   }


   /*   public void disconnect() {
      jac.core.ApplicationRepository.get()
         .unextend("contacts","remote-access");
      jac.aspects.tracing.Recorder.get().start();
   }

   public void reconnect() {
      jac.aspects.tracing.Recorder.get().stop();
      jac.core.ApplicationRepository.get()
         .extend("contacts","remote-access");
      jac.aspects.tracing.Recorder.get().replay(
         jac.aspects.tracing.Recorder.get().getNewObjectsClasses(),
         jac.aspects.tracing.Recorder.get().getCalls());
   }
   
   public void showLocalActions() {
      jac.aspects.tracing.Recorder.get().printRecordState();
      }*/

   public void mailing() {
      String toMail = "mailto:";
      Iterator it = contacts.iterator();
      boolean first = true;
      while(it.hasNext()) {
         Person c = (Person)it.next();
         if( c.getEmail()!=null && !c.getEmail().equals("") && 
             c.isMailing() ) 
         {
            if (first) {
               toMail=toMail+c.getEmail();
               first = false;
            } else {
               toMail=toMail+","+c.getEmail();
            }
         }
      }
      try {
         String command = "mozilla -mail "+toMail;
         System.out.println("launching "+command);
         Runtime.getRuntime().exec(command);
      } catch( Exception e ) {
         e.printStackTrace();
      }
   }

}
