/*

  Copyright (C) AOPSYS (http://www.aopsys.com)

  $licence$ */

package jac.samples.photos;

import jac.lib.java.util.Vector;
import jac.lib.java.util.HashSet;
import java.util.*;

public class PhotoRepository 
{

   public HashSet photos = new HashSet();
   
   public PhotoRepository () {
   }
   
   public Set getPhotos() {
      return photos;
   }

   public Photo[] searchTitle ( String title ) 
   {
      Iterator i = photos.iterator();
      java.util.Vector result = new java.util.Vector();
      while ( i.hasNext() ) {
         Photo curphoto = (Photo)i.next();
         if (curphoto.getTitle()!=null) {
            if ( curphoto.getTitle().indexOf( title ) != -1 ) {
               result.add ( curphoto );
            }
         }
      }
      Photo[] res = new Photo[result.size()];
      System.arraycopy(result.toArray(),0,res,0,result.size());
      return res;
   }
   
   public void addPhoto ( Photo photo ) {
      photos.add( photo );
   }
   
   public void delPhoto ( Photo photo ) {
      photos.remove ( photo );
   }

   /*
    * GUI methods
    */

   public static Person selectionHandler(jac.aspects.gui.CustomizedGUI gui,
                                         jac.core.rtti.CollectionItem collection,
                                         Photo photo) {
      System.out.println("selectionHandler("+photo+")");
      return photo.getAuthor();
   }
   
}

// Local Variables: ***
// c-basic-offset:3 ***
// End: **

